(define-module(ice-9 base64)#:use-module((srfi srfi-56)#:select(read-byte))#:export(base64-encode base64-decode))
(define(getb!-proc port)(lambda()(let((b(read-byte port)))(and(not(eof-object? b))b))))
(define(analyze-input input)(cond((string? input)(cons(getb!-proc(open-input-string input))(string-length input)))((port? input)(cons(getb!-proc input)(and(port-filename input)(let((guess(false-if-exception(stat:size(stat input)))))(and(number? guess)(positive? guess)guess)))))(else #f)))
(define c2i char->integer)
(define i2c integer->char)
(define(char+ c n)(i2c(+(c2i c)n)))
(define *reasonable-chunk*(ash 1(ash 1(ash 1(ash 1(ash 1 0))))))
(define subs make-shared-substring)
(define(make-buffer-stack size)(let((cur #f)(stack(quote()))(idx size))(define(new!)(set! cur(make-string size))(set! stack(cons cur stack))(set! idx 0))(define(spill!)(or(= idx size)(set-car! stack(subs(car stack)0 idx)))(let((res(apply string-append(reverse! stack))))(set! cur #f)(set! stack(quote()))(set! idx size)res))(lambda(c)(cond(c(and(= idx size)(new!))(string-set! cur idx c)(set! idx(1+ idx)))(else(spill!))))))
(define(make-outp-buffer outp size)(let((buf(make-string size))(idx 0)(count 0))(define(>OUT flush? x)(display x outp)(and flush?(force-output outp)))(define(new!)(>OUT #f buf)(set! idx 0))(define(spill!)(>OUT #t(if(= idx size)buf(subs buf 0 idx)))(set! idx 0)(let((rv count))(set! count 0)rv))(lambda(c)(cond(c(and(= idx size)(new!))(string-set! buf idx c)(set! idx(1+ idx))(set! count(1+ count)))(else(spill!))))))
(define(make-ob! output size)(if output(make-outp-buffer(if(eq? #t output)(current-output-port)output)(min *reasonable-chunk* size))(make-buffer-stack size)))
(define *enc-map*(let((em(make-vector 64 #f)))(vector-set! em 62 #\+)(vector-set! em 63 #\/)(do((i 0(1+ i)))((= i 26)em)(and(< i 10)(vector-set! em(+ 52 i)(char+ #\0 i)))(vector-set! em(+ 0 i)(char+ #\A i))(vector-set! em(+ 26 i)(char+ #\a i)))))
(define(encode! output getb! line-break crlf exp-input)(let*((bgrp(and line-break(quotient(max 4 line-break)4)))(ob!(make-ob! output(if exp-input(let((raw(* 4(inexact->exact(ceiling(/(1- exp-input)3))))))(+ raw(if bgrp(*(quotient raw(* 4 bgrp))(if crlf 2 1))0)))*reasonable-chunk*)))(lb!(if crlf(lambda()(ob! #\cr)(ob! #\newline))(lambda()(ob! #\newline)))))(define(acc! x)(ob!(if x(vector-ref *enc-map* x)#\=)))(let loop((group bgrp))(let*((g(getb!))(n(getb!))(u(getb!)))(cond(g(and bgrp(= 0 group)(begin(lb!)(set! group bgrp)))(acc!(ash g -2))(acc!(and(or g n)(logior(ash(logand(or g 0)3)4)(logand(ash(or n 0)-4)15))))(acc!(and(or n u)(logior(ash(logand(or n 0)15)2)(ash(or u 0)-6))))(acc!(and u(logand u 63)))))(if(and g n u)(loop(and bgrp(1- group)))(ob! #f))))))
(define (base64-encode out-port input . opts)(or(and=>(analyze-input input)(lambda(pair)(encode! out-port(car pair)(and(not(null? opts))(car opts))(and(not(null? opts))(not(null?(cdr opts)))(cadr opts))(cdr pair))))(error "bad input:" input)))
(define *dec-map*(let((dm(make-vector 256 #f)))(do((i 0(1+ i)))((= i 64)dm)(vector-set! dm(c2i(vector-ref *enc-map* i))i))))
(define byte-whitespace?(let((ws-bytes(map c2i(quote(#\space #\np #\newline #\cr #\ht #\vt)))))(lambda(b)(memq b ws-bytes))))
(define(decode! output getb! exp-input)(let((ob!(make-ob! output(if exp-input(inexact->exact(ceiling(* 3(/(1+ exp-input)4))))*reasonable-chunk*))))(define(acc! x)(ob!(i2c x)))(define(find!)(let((b(getb!)))(and b(if(byte-whitespace? b)(find!)(vector-ref *dec-map* b)))))(let loop()(let*((g(find!))(r(find!))(o(find!))(k(find!)))(and g r(acc!(logior(ash g 2)(ash r -4))))(and r o(acc!(logior(ash(logand r 15)4)(ash o -2))))(and o k(acc!(logior(ash(logand o 3)6)k)))(if(and g r o k)(loop)(ob! #f))))))
(define(base64-decode out-port input)(or(and=>(analyze-input input)(lambda(pair)(decode! out-port(car pair)(cdr pair))))(error "bad input:" input)))
