(define-module(ice-9 emacs)#:use-module((ice-9 gumm)#:select(fob-bound? save-module-excursion set-current-module module-name->fob current-module))#:use-module(ice-9 debug)#:use-module(ice-9 threads)#:use-module(ice-9 session)#:no-backtrace)
(define emacs-escape-character #\sub)
(define emacs-output-port(current-output-port))
(define(make-emacs-command char)(let((cmd(list->string(list emacs-escape-character char))))(lambda()(display cmd emacs-output-port))))
(define enter-input-wait(make-emacs-command #\s))
(define exit-input-wait(make-emacs-command #\f))
(define enter-read-character #\r)
(define sending-error(make-emacs-command #\F))
(define sending-backtrace(make-emacs-command #\B))
(define sending-result(make-emacs-command #\x))
(define end-of-text(make-emacs-command #\.))
(define no-stack(make-emacs-command #\S))
(define no-source(make-emacs-command #\R))
(add-hook! before-backtrace-hook sending-backtrace)
(add-hook! after-backtrace-hook end-of-text)
(add-hook! before-error-hook sending-error)
(add-hook! after-error-hook end-of-text)
(set-current-error-port emacs-output-port)
(add-hook! before-read-hook(lambda()(enter-input-wait)(force-output emacs-output-port)))
(add-hook! after-read-hook(lambda()(exit-input-wait)(force-output emacs-output-port)))
(define(make-emacs-load-port orig-port)(letrec((read-char-fn(lambda()(let((c(read-char orig-port)))(if(eq? c #\soh)(throw(quote end-of-chunk))c)))))(make-soft-port(vector #f #f #f read-char-fn(lambda()(close-port orig-port)))"r")))
(set-current-input-port(make-emacs-load-port(current-input-port)))
(define(result-to-emacs exp)(sending-result)(write exp emacs-output-port)(end-of-text)(force-output emacs-output-port))
(define load-acknowledge(make-emacs-command #\l))
(define load-port(current-input-port))
(define(flush-whitespace port)(catch(quote end-of-chunk)(lambda()(let loop((c(read-char port)))(cond((eof-object? c)(error "End of file while recieving Emacs data"))((memq c(list #\space #\ht #\newline #\np))(loop(read-char port)))((eq? c #\;)(let flush-line((c(read-char port)))(if(not(eq? c #\newline))(flush-line(read-char port))))(loop(read-char port)))(else(unread-char c port))))#f)(lambda args(read-char port)#t)))
(define(emacs-load filename linum colnum module interactivep)(set-port-filename! %%load-port filename)(set-port-line! %%load-port linum)(set-port-column! %%load-port colnum)(lazy-catch #t(lambda()(let loop((endp(flush-whitespace %%load-port)))(if(not endp)(begin(save-module-excursion(lambda()(if module(set-current-module(module-name->fob module #f)))(let((result(start-stack read-and-eval!(read-and-eval! %%load-port))))(if interactivep(result-to-emacs result)))))(loop(flush-whitespace %%load-port)))(begin(load-acknowledge)))(set-port-filename! %%load-port #f)))(lambda (key . args)(set-port-filename! %%load-port #f)(cond((eq? key(quote end-of-chunk))(fluid-set! the-last-stack #f)(set! stack-saved? #t)(scm-error(quote misc-error)#f "Incomplete expression"(quote())(quote())))((eq? key(quote exit)))(else(save-stack 2)(catch(quote end-of-chunk)(lambda()(let loop()(read-char %%load-port)(loop)))(lambda args #f))(apply throw key args))))))
(define(emacs-eval-request form)(result-to-emacs(eval form)))
(define(get-frame-source frame)(if(or(not(fluid-ref the-last-stack))(>= frame(stack-length(fluid-ref the-last-stack))))(begin(no-stack)#f)(let*((frame(stack-ref(fluid-ref the-last-stack)(frame-number->index frame)))(source(frame-source frame)))(or source(begin(no-source)#f)))))
(define(emacs-select-frame frame)(let((source(get-frame-source frame)))(if source(let((fname(source-property source(quote filename)))(line(source-property source(quote line)))(column(source-property source(quote column))))(if(and fname line column)(list fname line column)(begin(no-source)(quote()))))(quote()))))
(define (format template . rest)(let loop((chars(string->list template))(result(quote()))(rest rest))(cond((null? chars)(list->string(reverse result)))((char=?(car chars)#\%)(loop(cddr chars)(append(reverse(string->list(case(cadr chars)((#\S)(object->string(car rest)))((#\s)(object->string(car rest)display)))))result)(cdr rest)))(else(loop(cdr chars)(cons(car chars)result)rest)))))
(define(error-args->string args)(let((msg(apply format(caddr args)(cadddr args))))(if(symbol?(cadr args))(string-append(symbol->string(cadr args))": " msg)msg)))
(define(emacs-frame-eval frame form)(let((source(get-frame-source frame)))(if source(catch #t(lambda()(list(quote result)(object->string(local-eval(with-input-from-string form read)(memoized-environment source)))))(lambda args(list(car args)(error-args->string args))))(begin(no-source)(quote())))))
(define(emacs-symdoc symbol)(if(or(not(fob-bound?(current-module)symbol))(not(procedure?(eval symbol))))(quote nil)(procedure-documentation(eval symbol))))
(variable-set!(builtin-variable(quote %%load-port))load-port)
(variable-set!(builtin-variable(quote %%emacs-load))emacs-load)
(variable-set!(builtin-variable(quote %%emacs-eval-request))emacs-eval-request)
(variable-set!(builtin-variable(quote %%emacs-select-frame))emacs-select-frame)
(variable-set!(builtin-variable(quote %%emacs-frame-eval))emacs-frame-eval)
(variable-set!(builtin-variable(quote %%emacs-symdoc))emacs-symdoc)
(variable-set!(builtin-variable(quote %%apropos-internal))apropos-internal)
