(define-module(ice-9 gap-buffer)#:autoload(ice-9 rw)(write-string/partial)#:autoload(ice-9 receive)(receive)#:autoload(ice-9 regex)(string-match match:end)#:export(gb? make-gap-buffer gb-toggle-read-only gb-point gb-point-min gb-point-max gb-bolp gb-eolp gb-bobp gb-eobp gb-insert-string! gb-insert-char! gb-insert gb-delete-char! gb-delete-region gb-erase! gb-goto-char gb-forward-char gb-backward-char gb-forward-line gb-beginning-of-line gb-end-of-line gb-match-string gb-looking-at gb-match-beginning gb-match-end gb-search-forward gb-search-backward gb-re-search-forward gb-replace-match gb->port! gb->string gb->substring gb-filter! gb->lines gb-filter-lines! make-gap-buffer-port))
(define gap-buffer(make-record-type(quote gap-buffer)(quote(s gap-ofs aft-ofs ro))(lambda(obj port)(display "#<gap-buffer " port)(display(-(aft-ofs: obj)(gap-ofs: obj))port)(display #\/ port)(display(string-length(s: obj))port)(display #\: port)(display(gb-point-min obj)port)(display #\: port)(display(gb-point obj)port)(display #\: port)(display(gb-point-max obj)port)(display ">" port))))
(define(gb? object)((record-predicate gap-buffer)object))
(define s:(record-accessor gap-buffer(quote s)))
(define gap-ofs:(record-accessor gap-buffer(quote gap-ofs)))
(define aft-ofs:(record-accessor gap-buffer(quote aft-ofs)))
(define ro:(record-accessor gap-buffer(quote ro)))
(define s!(record-modifier gap-buffer(quote s)))
(define gap-ofs!(record-modifier gap-buffer(quote gap-ofs)))
(define aft-ofs!(record-modifier gap-buffer(quote aft-ofs)))
(define ro!(record-modifier gap-buffer(quote ro)))
(define(check-read-only gb)(and(ro: gb)(error "buffer read-only:" gb)))
(define default-chunk-size 1024)
(define default-realloc-threshold 32)
(define(round-up n)(* default-chunk-size(+ 1(quotient n default-chunk-size))))
(define new(record-constructor gap-buffer))
(define(realloc gb inc)(let*((old-s(s: gb))(all-sz(string-length old-s))(new-sz(+ all-sz inc))(gap-ofs(gap-ofs: gb))(aft-ofs(aft-ofs: gb))(new-s(make-string new-sz))(new-aft-ofs(+ aft-ofs inc)))(substring-move! old-s 0 gap-ofs new-s 0)(substring-move! old-s aft-ofs all-sz new-s new-aft-ofs)(s! gb new-s)(aft-ofs! gb new-aft-ofs)))
(define (make-gap-buffer . init)(define(string<- x)(cond((string? x)x)((port? x)(let((ls(list #f))(next(lambda()(read-char x))))(let loop((c(next))(tp ls))(if(eof-object? c)(list->string(cdr ls))(begin(set-cdr! tp(list c))(loop(next)(cdr tp)))))))(else(error "bad init type"))))(let*((string(if(null? init)""(string<-(car init))))(len(string-length string))(alloc(round-up len))(s(make-string alloc)))(substring-move! string 0 len s 0)(new s len alloc #f)))
(define (gb-toggle-read-only gb . arg)(let*((cur(ro: gb))(now(cond((null? arg)(not cur))((car arg)=>(lambda(v)(and v(number? v)(positive? v)))))))(and(not cur)now(let((gap(gap-ofs: gb))(aft(aft-ofs: gb)))(or(= gap aft)(let*((s(s: gb))(len(string-length s))(new(make-string(+ gap(- len aft)))))(substring-move! s 0 gap new 0)(substring-move! s aft len new gap)(s! gb new)(aft-ofs! gb gap)))))(ro! gb now))(if #f #f))
(define(gb-point gb)(1+(gap-ofs: gb)))
(define(gb-point-min gb)1)
(define(gb-point-max gb)(1+(-(string-length(s: gb))(-(aft-ofs: gb)(gap-ofs: gb)))))
(define(nl? s i)(char=? #\newline(string-ref s i)))
(define(gb-bolp gb)(or(=(gb-point gb)(gb-point-min gb))(nl?(s: gb)(1-(gap-ofs: gb)))))
(define(gb-eolp gb)(or(=(gb-point gb)(gb-point-max gb))(nl?(s: gb)(aft-ofs: gb))))
(define(gb-bobp gb)(= 1(gb-point gb)))
(define(gb-eobp gb)(=(gb-point-max gb)(gb-point gb)))
(define(insert-prep gb len)(let*((gap-ofs(gap-ofs: gb))(aft-ofs(aft-ofs: gb))(slack(-(- aft-ofs gap-ofs)len)))(and(< slack default-realloc-threshold)(realloc gb(round-up(- slack))))gap-ofs))
(define(gb-insert-string! gb string)(check-read-only gb)(let*((len(string-length string))(gap-ofs(insert-prep gb len)))(substring-move! string 0 len(s: gb)gap-ofs)(gap-ofs! gb(+ gap-ofs len))))
(define(gb-insert-char! gb char)(check-read-only gb)(let((gap-ofs(insert-prep gb 1)))(string-set!(s: gb)gap-ofs char)(gap-ofs! gb(+ gap-ofs 1))))
(define (gb-insert gb . args)(let((ins!(lambda(s)(gb-insert-string! gb s))))(for-each(lambda(x)(cond((gb? x)(ins!(gb->string x)))((char? x)(gb-insert-char! gb x))((string? x)(ins! x))((symbol? x)(ins!(symbol->string x)))((number? x)(ins!(number->string x)))((pair? x)(ins!(with-output-to-string(lambda()(write x)))))(else(error "wrong type arg"))))args)))
(define(gb-delete-char! gb count)(check-read-only gb)(cond((< count 0)(gap-ofs! gb(max 0(+(gap-ofs: gb)count))))((> count 0)(aft-ofs! gb(min(string-length(s: gb))(+(aft-ofs: gb)count))))((= count 0)#t)))
(define(gb-delete-region gb beg end)(check-read-only gb)(let((b(min beg end))(e(max beg end)))(gb-goto-char gb b)(gb-delete-char! gb(- e b))))
(define(gb-erase! gb)(check-read-only gb)(gap-ofs! gb 0)(aft-ofs! gb(string-length(s: gb))))
(define(point++n! gb n s gap-ofs aft-ofs)(substring-move-left! s aft-ofs(+ aft-ofs n)s gap-ofs)(gap-ofs! gb(+ gap-ofs n))(aft-ofs! gb(+ aft-ofs n)))
(define(point+-n! gb n s gap-ofs aft-ofs)(substring-move-right! s(+ gap-ofs n)gap-ofs s(+ aft-ofs n))(gap-ofs! gb(+ gap-ofs n))(aft-ofs! gb(+ aft-ofs n)))
(define(gb-goto-char gb new-point)(let((pmax(gb-point-max gb)))(or(and(< new-point 1)(gb-goto-char gb 1))(and(> new-point pmax)(gb-goto-char gb pmax))(let((delta(- new-point(gb-point gb))))(or(= delta 0)((if(< delta 0)point+-n! point++n!)gb delta(s: gb)(gap-ofs: gb)(aft-ofs: gb))))))new-point)
(define(gb-forward-char gb n)(or(= 0 n)((if(> n 0)point++n! point+-n!)gb n(s: gb)(gap-ofs: gb)(aft-ofs: gb))))
(define(gb-backward-char gb n)(gb-forward-char gb(- n)))
(define(forward-line-internal gb n)(let((s(s: gb))(gap(gap-ofs: gb))(aft(aft-ofs: gb)))(if(positive? n)(let loop((n n)(start aft)(at-least-one? #f))(cond((= 0 n)(point++n! gb(- start aft)s gap aft)(cons 0 at-least-one?))((string-index s #\newline start)=>(lambda(nl)(loop(1- n)(1+ nl)#t)))(else(cons(let((pmax(gb-point-max gb)))(cond((= pmax(gb-point gb))n)(else(gb-goto-char gb pmax)(if at-least-one? n(1- n)))))at-least-one?))))(let loop((n n)(end gap))(cond((= 1 n)(point+-n! gb(-(1+ end)gap)s gap aft)(cons 0 #f))((string-rindex s #\newline 0 end)=>(lambda(nl)(loop(1+ n)nl)))(else(gb-goto-char gb(gb-point-min gb))(cons n #f)))))))
(define (gb-forward-line gb . n)(car(forward-line-internal gb(if(null? n)1(car n)))))
(define (gb-beginning-of-line gb . n)(forward-line-internal gb(1-(if(null? n)1(car n))))#f)
(define (gb-end-of-line gb . n)(let*((n(if(null? n)1(car n)))(p-before(gb-point gb))(move-info(forward-line-internal gb n))(at-least-one?(cdr move-info))(p(gb-point gb)))(or(if(positive? n)(and(= p(gb-point-max gb))(if at-least-one?(< 1 n)(let((s(s: gb))(gap(gap-ofs: gb)))(or(= 1 n)(not(string-rindex s #\newline(- gap(- p p-before))gap))))))(= p(gb-point-min gb)))(gb-forward-char gb -1)))#f)
(define(guile-md->md guile-md ofs)(map(lambda(cell)(cons(+ ofs(car cell))(+ ofs(cdr cell))))(cdr(vector->list guile-md))))
(define --match-data(make-object-property))
(define(md gb)(--match-data gb))
(define(md! gb m)(set!(--match-data gb)m))
(define (gb-match-string gb n . string)(let((mn(list-ref(md gb)n)))(if(null? string)(bsub gb(1-(car mn))(1-(cdr mn)))(substring(car string)(car mn)(cdr mn)))))
(define(gb-looking-at gb re-str)(let*((s(s: gb))(start(aft-ofs: gb))(gm(if(char=? #\^(string-ref re-str 0))(string-match re-str s start regexp/newline)(string-match(string-append "^" re-str)s start))))(cond((and gm(= start(car(vector-ref gm 1))))(md! gb(guile-md->md gm(1+(-(gap-ofs: gb)start))))#t)(else #f))))
(define (gb-match-beginning gb . n)(car(list-ref(md gb)(if(null? n)0(car n)))))
(define (gb-match-end gb . n)(cdr(list-ref(md gb)(if(null? n)0(car n)))))
(define(parse-search-args gb edge args what)(let*((bound(if(or(null? args)(eq? #f(car args)))edge(car args)))(fail(cond((or(<(length args)2)(eq? #f(cadr args)))(lambda()(error "search failed:" what)))((eq? #t(cadr args))(lambda()#f))(else(lambda()(gb-goto-char gb bound)#f))))(reps(if(<(length args)3)1(caddr args))))(values bound fail reps)))
(define (gb-search-forward gb string . args)(let*((p(gb-point gb))(pmax(gb-point-max gb)))(receive(bound fail reps)(parse-search-args gb pmax args string)(if(string=? "" string)p(let*((len(string-length string))(len-1(1- len))(s(s: gb))(start(aft-ofs: gb))(fc(string-ref string 0))(lc(string-ref string(1- len)))(next(lambda(from)(string-index s fc from))))(let loop((alook(next start)))(let((look(and alook(+ p(- alook start)))))(cond((or(not look)(not(< look bound))(not(<(+ look len-1)bound)))(fail))((and(char=?(string-ref s(+ alook len-1))lc)(string=?(substring s alook(+ alook len))string))(set! reps(1- reps))(if(= 0 reps)(let((rest-point(+ look len)))(md! gb(quasiquote(((unquote look)unquote rest-point))))(gb-goto-char gb rest-point)rest-point)(loop(next(+ alook len)))))(else(loop(next(1+ alook))))))))))))
(define (gb-search-backward gb string . args)(let*((p(gb-point gb))(pmin(gb-point-min gb)))(receive(bound fail reps)(parse-search-args gb pmin args string)(if(string=? "" string)p(let*((len(string-length string))(len-1(1- len))(s(s: gb))(fc(string-ref string 0))(lc(string-ref string(1- len)))(next(lambda(to)(string-rindex s lc 0 to))))(let loop((blook(next(gap-ofs: gb))))(let((look(and blook(+ pmin blook))))(cond((or(not look)(not(>= look bound))(not(>=(- look len-1)bound)))(fail))((and(char=?(string-ref s(- blook len-1))fc)(string=?(substring s(- blook len-1)(1+ blook))string))(set! reps(1- reps))(if(= 0 reps)(let((rest-point(1+(- look len))))(md! gb(quasiquote(((unquote rest-point)unquote(1+ look)))))(gb-goto-char gb rest-point)rest-point)(loop(next(- blook len)))))(else(loop(next(1- blook))))))))))))
(define (gb-re-search-forward gb regexp . args)(let*((p(gb-point gb))(pmax(gb-point-max gb)))(receive(bound fail reps)(parse-search-args gb pmax args regexp)(if(and(string? regexp)(string=? "" regexp))p(let*((s(s: gb))(start(aft-ofs: gb))(rx(if(regexp? regexp)regexp(make-regexp regexp regexp/newline)))(next(lambda(from flag)(regexp-exec rx s from flag))))(let loop((amatch(next start(if(= p 1)0 regexp/notbol)))(reps(1- reps)))(cond((not amatch)(fail))((= 0 reps)(md! gb(guile-md->md amatch(1+(-(gap-ofs: gb)start))))(let((rest-point(gb-match-end gb)))(gb-goto-char gb rest-point)rest-point))(else(loop(next(match:end amatch)regexp/notbol)(1- reps))))))))))
(define(replacement-text gb newtext)(define(err!)(error "invalid use of `\\' in replacement text"))(let*((last-char(1-(string-length newtext)))(c-zero-as-num(char->integer #\0)))(define(nrep n)(gb-match-string gb n))(define(crep c)(nrep(-(char->integer c)c-zero-as-num)))(let loop((start 0)(acc(quote())))(cond((string-index newtext #\\ start)=>(lambda(cut)(and(= cut last-char)(err!))(let((pre(substring newtext start cut))(c2(string-ref newtext(1+ cut))))(case c2((#\&)(loop(+ 2 cut)(list*(nrep 0)pre acc)))((#\\)(loop(+ 2 cut)(list* "\\" pre acc)))((#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9)(loop(+ 2 cut)(list*(crep c2)pre acc)))(else(err!))))))(else(apply string-append(reverse!(cons(substring newtext start)acc))))))))
(define (gb-replace-match gb newtext . args)(check-read-only gb)(let*((m(md gb))(buhbye(list-ref m 0))(rtxt(if(or(and(< 1(length args))(cadr args))(not(string-index newtext #\\)))newtext(replacement-text gb newtext))))(gb-goto-char gb(cdr buhbye))(gb-delete-char! gb(-(car buhbye)(cdr buhbye)))(gb-insert-string! gb rtxt)))
(define (gb->port! gb port . opts)(let*((s(s: gb))(len(string-length s))(gap(gap-ofs: gb))(aft(aft-ofs: gb)))(define(chunk->port! start end)(let loop((this-time(write-string/partial s port start end))(so-far start))(and(<(+ so-far this-time)end)(loop(write-string/partial s port(+ so-far this-time)end)(+ so-far this-time)))))(cond((null? opts)(chunk->port! 0 gap)(chunk->port! aft len))(else(let*((beg(1-(car opts)))(end(if(null?(cdr opts))len(let((v(1-(cadr opts))))(cond((< gap v)(+ v(- aft gap)))(else(set! gap v)#f))))))(chunk->port! beg gap)(and end(chunk->port! aft end)))))))
(define(gb->string gb)(let*((s(s: gb))(len(string-length s))(gap(gap-ofs: gb))(aft(aft-ofs: gb))(rv(make-string(+ gap(- len aft)))))(substring-move! s 0 gap rv 0)(substring-move! s aft len rv gap)rv))
(define(bsub gb x y)(let((s(s: gb))(gap(gap-ofs: gb)))(if(< y gap)(substring s x y)(let((aft(aft-ofs: gb)))(if(< gap x)(substring s(+(- x gap)aft)(+(- y gap)aft))(string-append(substring s x gap)(substring s aft(+(- y gap)aft))))))))
(define(gb->substring gb start end)(or(<= start end)((lambda(new-end new-start)(set! start new-start)(set! end new-end))start end))(or(<=(gb-point-min gb)start)(error "arg out of range:" start))(or(<= end(gb-point-max gb))(error "arg out of range:" end))(bsub gb(1- start)(1- end)))
(define(gb-filter! gb string-proc)(check-read-only gb)(let((new(string-proc(gb->string gb))))(gb-erase! gb)(gb-insert-string! gb new)))
(define(gb->lines gb)(let((s(s: gb))(rv(quote())))(define(add! line)(set! rv(cons line rv)))(define(splice! line)(set-car! rv(string-append line(car rv))))(define(->lines! check-splice? end beg)(let loop((rpos end)(just-found? #f))(define(sub lpos)(substring s lpos rpos))(cond((string-rindex s #\newline beg rpos)=>(lambda(i)((cond((and check-splice?(not(null? rv)))(set! check-splice? #f)(if(=(1- end)i)identity splice!))(else add!))(sub(1+ i)))(loop i #t)))((and(= beg rpos)check-splice?(not just-found?)))(else((if check-splice? splice! add!)(sub beg))))))(->lines! #f(string-length s)(aft-ofs: gb))(->lines! #t(gap-ofs: gb)0)rv))
(define(gb-filter-lines! gb lines-proc)(check-read-only gb)(let((ls(lines-proc(gb->lines gb))))(gb-erase! gb)(or(null? ls)(let*((lengths(map string-length ls))(gap-ofs(insert-prep gb(apply +(length ls)-1 lengths)))(s(s: gb)))(let*((head(car ls))(hlen(car lengths)))(substring-move! head 0 hlen s gap-ofs)(set! gap-ofs(+ hlen gap-ofs)))(for-each(lambda(head hlen)(string-set! s gap-ofs #\newline)(substring-move! head 0 hlen s(1+ gap-ofs))(set! gap-ofs(+ 1 hlen gap-ofs)))(cdr ls)(cdr lengths))(gap-ofs! gb gap-ofs)))))
(define(make-gap-buffer-port gb)(or(gb? gb)(error "not a gap-buffer:" gb))(make-soft-port(vector(lambda(c)(gb-insert-char! gb c))(lambda(s)(gb-insert-string! gb s))#f(lambda()(let((gap-ofs(gap-ofs: gb))(aft-ofs(aft-ofs: gb))(s(s: gb)))(if(= aft-ofs(string-length s))#f(let((c(string-ref s aft-ofs)))(string-set! s gap-ofs c)(gap-ofs! gb(1+ gap-ofs))(aft-ofs! gb(1+ aft-ofs))c))))#f)"rw"))
