(define-module(ice-9 getopt-long)#:export(getopt-long option-ref))
(define option-spec-fields(quote(name required? single-char predicate value-policy merge-multiple?)))
(define field-count(length option-spec-fields))
(define(make-option-spec name)(apply vector name(make-list(1- field-count)#f)))
(define(define-one-accessor field position)(quasiquote(define((unquote(symbol-append(quote s:)field))option-spec-object)(vector-ref option-spec-object(unquote position)))))
(define(define-one-modifier field position)(quasiquote(define((unquote(symbol-append(quote s:)field(quote !)))option-spec-object new-value)(vector-set! option-spec-object(unquote position)new-value))))
(defmacro define-all-accessors/modifiers()(quasiquote(begin(unquote-splicing(map define-one-accessor option-spec-fields(iota field-count)))(unquote-splicing(map define-one-modifier option-spec-fields(iota field-count))))))
(define-all-accessors/modifiers)
(define(parse-option-spec desc)(let*((name(car desc))(spec(make-option-spec name)))(for-each(lambda(desc-elem)(let((given(lambda()(cadr desc-elem))))(case(car desc-elem)((required?)(s:required?! spec(given)))((value)(s:value-policy! spec(given)))((single-char)(or(char?(given))(error "`single-char' value must be a char!"))(s:single-char! spec(given)))((predicate)(s:predicate! spec(given)))((merge-multiple?)(s:merge-multiple?! spec(given)))(else(error "invalid getopt-long option property:"(car desc-elem))))))(cdr desc))spec))
(define(split-arg-list argument-list)(let loop((yes(quote()))(no argument-list))(cond((null? no)(cons(reverse! yes)no))((string=? "--"(car no))(cons(reverse! yes)(cdr no)))(else(loop(cons(car no)yes)(cdr no))))))
(define short-opt-rx(make-regexp "^-([a-zA-Z]+)(.*)"))
(define long-opt-no-value-rx(make-regexp "^--([^=]+)$"))
(define long-opt-with-value-rx(make-regexp "^--([^=]+)=(.*)"))
(define(msub match which)(let((sel(vector-ref match(1+ which))))(substring(vector-ref match 0)(car sel)(cdr sel))))
(define(expand-clumped-singles opt-ls)(let loop((opt-ls opt-ls)(ret-ls(quote())))(cond((null? opt-ls)(reverse! ret-ls))((regexp-exec short-opt-rx(car opt-ls))=>(lambda(match)(let((singles(reverse!(map(lambda(c)(string-append "-"(make-string 1 c)))(string->list(msub match 1)))))(extra(msub match 2)))(loop(cdr opt-ls)(append(if(string-null? extra)singles(cons extra singles))ret-ls)))))(else(loop(cdr opt-ls)(cons(car opt-ls)ret-ls))))))
(define(looks-like-an-option string)(define(m? rx)(regexp-exec rx string))(or(m? short-opt-rx)(m? long-opt-with-value-rx)(m? long-opt-no-value-rx)))
(define(process-options specs argument-ls)(let*((idx(map(lambda(spec)(cons(s:name spec)spec))specs))(sc-idx(let loop((ls specs)(acc(quote())))(if(null? ls)acc(loop(cdr ls)(let*((spec(car ls))(sc(s:single-char spec)))(if sc(acons sc spec acc)acc))))))(found(list(quote(#f))))(found-tp found)(etc(list #f))(etc-tp etc))(define(found! x)(set-cdr! found-tp(list x))(set! found-tp(cdr found-tp)))(define(etc! x)(set-cdr! etc-tp(list x))(set! etc-tp(cdr etc-tp)))(define(ERR:no-such x)(error "no such option:" x))(let loop((arg-ls argument-ls))(define(check two? rx)(and=>(regexp-exec rx(car arg-ls))(lambda(m)(let((one(msub m 1)))(if two?(cons one(msub m 2))one)))))(define(eat! spec ls)(let((val!loop(lambda(val rest)(let*((mm?(s:merge-multiple? spec))(who(s:name spec))(old(and mm?(assq-ref found who))))(if old(set-cdr!(last-pair old)(list val))(found!(cons who(if mm?(list val)val))))(loop(rest ls)))))(no-following?(lambda()(or(null?(cdr ls))(looks-like-an-option(cadr ls))))))(case(s:value-policy spec)((optional)(if(no-following?)(val!loop #t cdr)(val!loop(cadr ls)cddr)))((#t)(if(no-following?)(error "option must be specified with argument:"(s:name spec))(val!loop(cadr ls)cddr)))(else(val!loop #t cdr)))))(cond((null? arg-ls))((check #f short-opt-rx)=>(lambda(c)(eat!(or(assq-ref sc-idx(string-ref c 0))(ERR:no-such c))arg-ls)))((check #f long-opt-no-value-rx)=>(lambda(opt)(eat!(or(assq-ref idx(string->symbol opt))(ERR:no-such opt))arg-ls)))((check #t long-opt-with-value-rx)=>(lambda(pair)(let*((opt(car pair))(spec(or(assq-ref idx(string->symbol opt))(ERR:no-such opt))))(if(s:value-policy spec)(eat! spec(append(list(quote ignored)(cdr pair))(cdr arg-ls)))(error "option does not support argument:" opt)))))(else(etc!(car arg-ls))(loop(cdr arg-ls)))))(cons(cdr found)(cdr etc))))
(define(getopt-long args grammar)(let*((program-arguments args)(option-desc-list grammar)(specifications(map parse-option-spec option-desc-list))(pair(split-arg-list(cdr program-arguments)))(split-ls(expand-clumped-singles(car pair)))(non-split-ls(cdr pair))(found/etc(process-options specifications split-ls))(found(car found/etc))(rest-ls(append(cdr found/etc)non-split-ls)))(for-each(lambda(spec)(let((name(s:name spec)))(and(s:required? spec)(or(assq name found)(error "option must be specified:" name)))(and=>(and(assq name found)(s:predicate spec))(lambda(pred)(let((p!(lambda(val)(or(pred val)(error "option predicate failed:" name)))))(if(s:merge-multiple? spec)(for-each p!(assq-ref found name))(let loop((ls found))(cond((null? ls))(else(and(eq?(caar ls)name)(p!(cdar ls)))(loop(cdr ls)))))))))))specifications)(acons(quote())rest-ls found)))
(define(option-ref options key default)(or(assq-ref options key)default))
