(define-module(ice-9 infix)#:use-module(ice-9 optargs-kw)#:export(make-read-tokenizer add-infix-operator add-prefix-operator helper-nth read-infix-expr infix-string->expr activate-infix))
(define(%% s arg)(simple-format #f s arg))
(define(remove-if-not pred? l)(do((l l(cdr l))(r(quote())(if(pred?(car l))(cons(car l)r)r)))((null? l)(reverse! r))))
(define (sloppy-min . lst)(let((nlst(remove-if-not number? lst)))(and(pair? nlst)(apply min nlst))))
(define(make-read-tokenizer port)(define(get-token)(let((ch(read-char port)))(cond((eof-object? ch)ch)((char-whitespace? ch)(get-token))((memq ch(quote(#\( #\) #\[ #\] #\,)))ch)((eq? ch #\;)(%read-line)(get-token))(else(unread-char ch port)(let((sym(read port)))(if(symbol? sym)(let((str(symbol->string sym)))(cond((sloppy-min(string-index str #\,)(string-index str #\[)(string-index str #\]))=>(lambda(idx)(let((sub(substring str 0 idx)))(unread-string(substring str idx)port)(or(string->number sub)(string->symbol sub)))))(else sym)))sym))))))get-token)
(define(char-rparen? x)(eq? x #\)))
(define(char-rbracket? x)(eq? x #\]))
(define(helper-nth o n)(cond((vector? o)(vector-ref o n))((pair? o)(list-ref o n))((string? o)(string-ref o n))(else(error "Do not know how to handle [] operator"))))
(define infix-ops(make-vector 11))
(define infix-func(make-vector 11))
(define infix-right(make-vector 11))
(define*(add-infix-operator name priority #:key(right #f)(func #f))(hashq-set! infix-ops name priority)(if right(hashq-set! infix-right name #t))(if func(hashq-set! infix-func name func)))
(define prefix-ops(make-vector 11))
(define prefix-func(make-vector 11))
(define*(add-prefix-operator name priority #:key(func #f))(hashq-set! prefix-ops name priority)(if func(hashq-set! prefix-func name func)))
(define(get-infix-priority op)(hashq-ref infix-ops op))
(define(get-infix-func op)(hashq-ref infix-func op op))
(define(infix-right-assoc? op)(hashq-ref infix-right op))
(define op-priority car)
(define op-func cadr)
(define op-nof cddr)
(define push cons)
(define(make-op func priority nof)(cons* priority func nof))
(define(stack-apply-op s op)(let((nof(op-nof op)))(cons(cons(op-func op)(reverse!(list-head s nof)))(list-tail s nof))))
(define(read-infix-expr get-token end? allow-commas)(let loop((stack(quote()))(ops(quote()))(token(get-token))(unary? #t))(define(flush)(let flush-loop((stack stack)(ops ops))(if(null? ops)(car stack)(flush-loop(stack-apply-op stack(car ops))(cdr ops)))))(define(continue func priority nof right? unary?)(let iloop((stack stack)(ops ops))(if(and(pair? ops)(not(and right?(eq? func(op-func(car ops)))))(<= priority(op-priority(car ops))))(iloop(stack-apply-op stack(car ops))(cdr ops))(loop stack(push(make-op func priority nof)ops)(get-token)unary?))))(if unary?(cond((eq? token #\()(loop(push(read-infix-expr get-token char-rparen? #f)stack)ops(get-token)#f))((eof-object? token)(error "Unexpected EOF"))((end? token)(error(%% "Unexpected ~A" token)))(else(let((priority(get-infix-priority token)))(if priority(continue(get-infix-func token)priority 1 #f #t)(loop(push token stack)ops(get-token)#f)))))(cond((and(eq? token #\()(symbol?(car stack)))(loop(push(cons(car stack)(read-infix-expr get-token char-rparen? #t))(cdr stack))ops(get-token)#f))((eq? token #\[)(loop(push(list helper-nth(car stack)(read-infix-expr get-token char-rbracket? #f))(cdr stack))ops(get-token)#f))((and allow-commas(eq? token #\,))(cons(flush)(loop(quote())(quote())(get-token)#t)))((end? token)((if allow-commas list identity)(flush)))((eof-object? token)(error "Unexpected EOF"))(else(let((priority(get-infix-priority token)))(if priority(continue(get-infix-func token)priority 2(infix-right-assoc? token)#t)(error(%% "Unknown infix operator ~A" token)))))))))
(define(infix-string->expr s)(read-infix-expr(make-read-tokenizer(open-input-string s))eof-object? #f))
(define(read-hash-infix _ port)(read-infix-expr(make-read-tokenizer port)char-rbracket? #f))
(define(activate-infix)(read-hash-extend #\[ read-hash-infix))
(add-infix-operator(quote ||)5 #:func(quote or))
(add-infix-operator(quote &&)10 #:func(quote and))
(add-infix-operator(quote <)15)
(add-infix-operator(quote >)15)
(add-infix-operator(quote ==)15 #:func(quote eq?))
(add-infix-operator(quote <=)15)
(add-infix-operator(quote >=)15)
(add-infix-operator(quote +)20)
(add-infix-operator(quote -)20)
(add-infix-operator(quote *)25)
(add-infix-operator(quote /)25)
(add-infix-operator(quote %)25 #:func(quote modulo))
(add-infix-operator(quote ^)35 #:func(quote expt)#:right #t)
(add-infix-operator(quote **)35 #:func(quote expt)#:right #t)
(add-prefix-operator(quote !)40 #:func(quote not))
(add-prefix-operator(quote -)40)
