(define-module(ice-9 popen)#:export(port/pid-table open-pipe close-pipe open-input-pipe open-output-pipe))
(define pipe-guardian(make-guardian))
(define port/pid-table(make-hash-table #:size 31 #:weakness #:key))
(define(ensure-fdes port mode)(or(false-if-exception(fileno port))(open-fdes *null-device* mode)))
(define (open-process mode prog . args)(let((p(pipe))(reading(string=? mode OPEN_READ)))(setvbuf(cdr p)_IONBF)(let((pid(primitive-fork)))(cond((= pid 0)(set-batch-mode?! #t)(let((input-fdes(if reading(ensure-fdes(current-input-port)O_RDONLY)(fileno(car p))))(output-fdes(if reading(fileno(cdr p))(ensure-fdes(current-output-port)O_WRONLY)))(error-fdes(ensure-fdes(current-error-port)O_WRONLY)))(close-all-fdes-except input-fdes output-fdes error-fdes)(cond((not(= input-fdes 0))(if(= output-fdes 0)(set! output-fdes(dup->fdes 0)))(if(= error-fdes 0)(set! error-fdes(dup->fdes 0)))(dup2 input-fdes 0)(fcntl input-fdes F_SETFD FD_CLOEXEC)))(cond((not(= output-fdes 1))(if(= error-fdes 1)(set! error-fdes(dup->fdes 1)))(dup2 output-fdes 1)(fcntl output-fdes F_SETFD FD_CLOEXEC)))(cond((not(= error-fdes 2))(dup2 error-fdes 2)(fcntl error-fdes F_SETFD FD_CLOEXEC)))(apply execlp prog prog args)))(else(if reading(close-port(cdr p))(close-port(car p)))(cons(if reading(car p)(cdr p))pid))))))
(define(open-pipe command mode)(let*((port/pid(open-process mode "/bin/sh" "-c" command))(port(car port/pid)))(pipe-guardian port)(hashq-set! port/pid-table port(cdr port/pid))port))
(define(fetch-pid port)(let((pid(hashq-ref port/pid-table port)))(hashq-remove! port/pid-table port)pid))
(define(close-process port/pid)(close-port(car port/pid))(cdr(waitpid(cdr port/pid))))
(define(close-process-quietly port/pid)(catch(quote system-error)(lambda()(close-port(car port/pid)))(lambda args #f))(catch(quote system-error)(lambda()(let((pid/status(waitpid(cdr port/pid)WNOHANG)))(cond((=(car pid/status)0)(pipe-guardian(car port/pid))(hashq-set! port/pid-table(car port/pid)(cdr port/pid))))))(lambda args #f)))
(define(close-pipe p)(let((pid(fetch-pid p)))(if(not pid)(error "close-pipe: pipe not in table"))(close-process(cons p pid))))
(define reap-pipes(lambda()(let loop((p(pipe-guardian)))(cond(p(let((pid(fetch-pid p)))(if pid(close-process-quietly(cons p pid))))(loop(pipe-guardian)))))))
(set! gc-thunk(let((old-thunk gc-thunk))(lambda()(if old-thunk(old-thunk))(reap-pipes))))
(define(open-input-pipe command)(open-pipe command OPEN_READ))
(define(open-output-pipe command)(open-pipe command OPEN_WRITE))
