(define-module(ice-9 regex))
(define-public(match:count match)(-(vector-length match)1))
(define-public(match:string match)(vector-ref match 0))
(define-public(match:prefix match)(make-shared-substring(match:string match)0(match:start match 0)))
(define-public(match:suffix match)(make-shared-substring(match:string match)(match:end match 0)))
(define-public(regexp-match? match)(and(vector? match)(string?(vector-ref match 0))(let loop((i 1))(cond((>= i(vector-length match))#t)((and(pair?(vector-ref match i))(integer?(car(vector-ref match i)))(integer?(cdr(vector-ref match i))))(loop(+ 1 i)))(else #f)))))
(define-public(regexp-quote regexp)(call-with-output-string(lambda(p)(let loop((i 0))(and(< i(string-length regexp))(begin(case(string-ref regexp i)((#\* #\. #\( #\) #\+ #\? #\\ #\^ #\$ #\{ #\})(write-char #\\ p)))(write-char(string-ref regexp i)p)(loop(1+ i))))))))
(define-public (match:start match . args)(let*((matchnum(if(pair? args)(+ 1(car args))1))(start(car(vector-ref match matchnum))))(if(= start -1)#f start)))
(define-public (match:end match . args)(let*((matchnum(if(pair? args)(+ 1(car args))1))(end(cdr(vector-ref match matchnum))))(if(= end -1)#f end)))
(define-public (match:substring match . args)(let*((matchnum(if(pair? args)(car args)0))(start(match:start match matchnum))(end(match:end match matchnum)))(and start end(make-shared-substring(match:string match)start end))))
(define-public (string-match pattern str . args)(let((rx(make-regexp pattern))(start(if(pair? args)(car args)0)))(regexp-exec rx str start)))
(define-public (regexp-substitute port match . items)(if(not port)(call-with-output-string(lambda(p)(apply regexp-substitute p match items)))(for-each(lambda(obj)(cond((string? obj)(display obj port))((integer? obj)(display(match:substring match obj)port))((eq?(quote pre)obj)(display(match:prefix match)port))((eq?(quote post)obj)(display(match:suffix match)port))(else(error(quote wrong-type-arg)obj))))items)))
(define-public (fold-matches regexp string init proc . flags)(let((regexp(if(regexp? regexp)regexp(make-regexp regexp)))(flags(if(null? flags)0 flags)))(let loop((start 0)(value init)(abuts #f))(let((m(if(> start(string-length string))#f(regexp-exec regexp string start flags))))(cond((not m)value)((and(=(match:start m)(match:end m))abuts)(loop(+ start 1)value #f))(else(loop(match:end m)(proc m value)#t)))))))
(define-public (list-matches regexp string . flags)(reverse!(apply fold-matches regexp string(quote())cons flags)))
(define-public (regexp-substitute/global port regexp string . items)(if(not port)(call-with-output-string(lambda(p)(apply regexp-substitute/global p regexp string items)))(let next-match((matches(list-matches regexp string))(start 0))(if(null? matches)(display(make-shared-substring string start)port)(let((m(car matches)))(let next-item((items items))(define(do-item item)(cond((string? item)(display item port))((integer? item)(display(match:substring m item)port))((procedure? item)(display(item m)port))((eq? item(quote pre))(display(make-shared-substring string start(match:start m))port))((eq? item(quote post))(next-match(cdr matches)(match:end m)))(else(error(quote wrong-type-arg)item))))(if(pair? items)(if(null?(cdr items))(do-item(car items))(begin(do-item(car items))(next-item(cdr items)))))))))))
