(define-module(ice-9 session)#:use-module((ice-9 gumm)#:select(fob-info fob-set-system! fob-ref nested-ref unique-fob current-module eval-in-module))#:use-module(ice-9 documentation)#:use-module(ice-9 regex)#:export(add-to-load-path! help apropos apropos-internal apropos-fold apropos-fold-accessible apropos-fold-exported apropos-fold-all source arity system-module)#:re-export(current-module eval-in-module))
(define (add-to-load-path! dir . opt)(let((dir(if(symbol? dir)(symbol->string dir)dir)))(or(member dir %load-path)(set! %load-path(if(or(null? opt)(not(car opt)))(cons dir %load-path)(append %load-path(list dir)))))))
(define help(procedure->syntax(lambda(exp env)"(help [NAME])\nPrints useful information.  Try `(help)'."(cond((not(=(length exp)2))(display(symbol->string *help-usage*)))((not(feature?(quote regex)))(display "`help' depends on the `regex' feature.\nYou don't seem to have regular expressions installed.\n"))(else(let((name(cadr exp))(not-found(lambda(type x)(simple-format #t "No ~A found for ~A\n" type x))))(cond((symbol? name)(help-doc name(simple-format #f "^~A$"(regexp-quote(symbol->string name)))))((string? name)(help-doc name name))((and(list? name)(=(length name)2)(eq?(car name)(quote unquote)))(cond((object-documentation(local-eval(cadr name)env))=> write-line)(else(not-found(quote documentation)(cadr name)))))((and(list? name)(=(length name)2)(eq?(car name)(quote quote))(symbol?(cadr name)))(cond((search-documentation-files(cadr name))=> write-line)(else(not-found(quote documentation)(cadr name)))))((and(list? name)(and-map symbol? name)(not(null? name))(not(eq?(car name)(quote quote))))(cond((module-commentary name)=>(lambda(doc)(display name)(write-line " commentary:")(write-line doc)))(else(not-found(quote commentary)name))))(else(display(symbol->string *help-usage*))))*unspecified*))))))
(define(help-doc term regexp)(let((entries(apropos-fold(lambda(module name object data)(cons(list module name(object-documentation object)(cond((closure? object)"a procedure")((procedure? object)"a primitive procedure")(else "an object")))data))(quote())regexp apropos-fold-exported))(module car)(name cadr)(doc caddr)(type cadddr))(cond((not(null? entries))(let((first? #t)(undocumented-entries(quote()))(documented-entries(quote()))(documentations(quote())))(for-each(lambda(entry)(let((entry-summary(simple-format #f "~S: ~S\n"(fob-info(module entry)#:name)(name entry))))(if(doc entry)(begin(set! documented-entries(cons entry-summary documented-entries))(set! documentations(cons(simple-format #f "`~S' is ~A in the ~S module.\n\n~A\n"(name entry)(type entry)(fob-info(module entry)#:name)(doc entry))documentations)))(set! undocumented-entries(cons entry-summary undocumented-entries)))))entries)(if(and(not(null? documented-entries))(or(>(length documented-entries)1)(not(null? undocumented-entries))))(begin(display "Documentation found for:\n")(for-each display documented-entries)(set! first? #f)))(for-each(lambda(entry)(if first?(set! first? #f)(newline))(display entry))documentations)(if(not(null? undocumented-entries))(begin(if first?(set! first? #f)(newline))(display "No documentation found for:\n")(for-each display undocumented-entries)))))((search-documentation-files term)=>(lambda(doc)(write-line "Documentation from file:")(write-line doc)))(else(display "Did not find any object ")(simple-format #t(if(symbol? term)"named `~A'\n" "matching regexp \"~A\"\n")term)))))
(define *help-usage*(quote #{\
Usage:\ \(help\ NAME\)\ shows\ documentation\ about\ objects\ named\ NAME\ \(an\ object\)\
\ \ \ \ \ \ \ \(help\ \"REGEXP\"\)\ ditto\ for\ objects\ with\ names\ matching\ REGEXP\
\ \ \ \ \ \ \ \(help\ 'NAME\)\ shows\ documentation\ for\ NAME,\ even\ if\ it\ is\ not\ an\ object\
\ \ \ \ \ \ \ \(help\ ,EXPR\)\ shows\ documentation\ for\ object\ returned\ by\ EXPR\
\ \ \ \ \ \ \ \(help\ \(my\ module\)\)\ shows\ module\ commentary\ for\ `\(my\ module\)'\
\ \ \ \ \ \ \ \(help\)\ shows\ this\ text\
\
`help'\ searches\ among\ bindings\ exported\ from\ loaded\ modules,\ while\
`apropos'\ searches\ among\ bindings\ visible\ from\ the\ \"current\"\ module.\
\
Examples:\ \(help\ help\)\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \;\ macro\
\ \ \ \ \ \ \ \ \ \ \(help\ cons\)\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \;\ procedure\
\ \ \ \ \ \ \ \ \ \ \(help\ \(ice-9\ common-list\)\)\ \ \ \ \;\ module\ name\
\ \ \ \ \ \ \ \ \ \ \(help\ \"output-string\"\)\ \ \ \ \ \ \ \ \;\ regexp\
\
Other\ useful\ sources\ of\ helpful\ information:\
\
\ \(apropos\ STRING\)\
\ \(arity\ PROCEDURE\)\
\ \(name\ PROCEDURE-OR-MACRO\)\
\ \(source\ PROCEDURE-OR-MACRO\)\
\
Tools:\
\
\ \(backtrace\)\	\	\	\	\;\ show\ backtrace\ from\ last\ error\
\ \(debug\)\	\	\	\	\;\ enter\ the\ debugger\
\ \(trace\ [PROCEDURE]\)\	\	\	\;\ trace\ procedure\ \(no\ arg\ =>\ show\)\
\ \(untrace\ [PROCEDURE]\)\	\	\	\;\ untrace\ \(no\ arg\ =>\ untrace\ all\)\
\
\ \(OPTIONSET-options\ 'full\)\	\	\;\ display\ option\ information\
\ \(OPTIONSET-enable\ 'OPTION\)\
\ \(OPTIONSET-disable\ 'OPTION\)\
\ \(OPTIONSET-set!\ OPTION\ VALUE\)\
\
where\ OPTIONSET\ is\ one\ of\ debug,\ read,\ eval,\ print\
\
}#))
(define built-in?(let((b-fobs(map unique-fob(quote(#:scm #:root)))))(lambda(x)(memq x b-fobs))))
(define (apropos rgx . options) "Search for bindings matching @var{rgx}, a regular expression string.\n@var{options} are symbols: @code{full}, @code{shadow}, @code{value}."(if(zero?(string-length rgx))"Empty string not allowed"(let*((match(make-regexp rgx))(modules(cons(current-module)(fob-info(current-module)#:uses)))(separator #\ht)(shadow(member(quote shadow)options))(value(member(quote value)options)))(cond((member(quote full)options)(set! shadow #t)(set! value #t)))(for-each(lambda(module)(let*((builtin(built-in? module))(name(fob-info module #:name))(obarrays(if builtin(list(builtin-weak-bindings)(builtin-bindings))(list(fob-info module #:obarray))))(get-refs(if builtin(list identity identity)(list variable-ref))))(for-each(lambda(obarray deref)(hash-for-each(lambda(sym ref)(cond((regexp-exec match(symbol->string sym))(display name)(display ": ")(display sym)(cond((or value(procedure?(deref ref)))(display separator)(display(deref ref))))(and shadow(not(eq?(fob-ref module sym)(fob-ref(current-module)sym)))(display " shadowed"))(newline))))obarray))obarrays get-refs)))modules))))
(define(apropos-internal rgx)"Return a list of accessible variable names for @var{rgx}."(apropos-fold(lambda(module name var data)(cons name data))(quote())rgx(apropos-fold-accessible(current-module))))
(define(apropos-fold proc init rgx folder)"Fold PROCEDURE over bindings matching third arg REGEXP.\n\nResult is\n\n@example\n  (PROCEDURE MODULE1 NAME1 VALUE1\n    (PROCEDURE MODULE2 NAME2 VALUE2\n      ...\n      (PROCEDURE MODULEn NAMEn VALUEn INIT)))\n@end example\n\nwhere INIT is the second arg to `apropos-fold'.\n\nFourth arg FOLDER is one of\n\n@example\n  (apropos-fold-accessible MODULE) ;fold over bindings accessible in MODULE\n  apropos-fold-exported\t\t   ;fold over all exported bindings\n  apropos-fold-all\t\t   ;fold over all bindings\n@end example"(let((match(make-regexp rgx))(recorded(make-hash-table #:size 61)))(let((fold-module(lambda(module data)(let*((obarray-filter(lambda(name val data)(if(and(regexp-exec match name)(not(hashq-get-handle recorded name)))(begin(hashq-set! recorded name #t)(proc module name val data))data)))(module-filter(lambda(name var data)(obarray-filter name(variable-ref var)data))))(cond((built-in? module)(hash-fold obarray-filter(hash-fold obarray-filter data(builtin-bindings))(builtin-weak-bindings)))(module(hash-fold module-filter data(fob-info module #:obarray)))(else data))))))(folder fold-module init))))
(define(make-fold-modules init-thunk traverse extract)"Return procedure capable of traversing a forest of modules.\nThe forest traversed is the image of the forest generated by root\nmodules returned by INIT-THUNK and the generator TRAVERSE.\nIt is an image under the mapping EXTRACT."(lambda(fold-module init)(let*((table(make-hash-table #:size 31))(first?(lambda(obj)(let*((handle(hash-create-handle! table obj #t))(first?(cdr handle)))(set-cdr! handle #f)first?))))(let rec((data init)(modules(init-thunk)))(do((modules modules(cdr modules))(data data(if(first?(car modules))(rec(fold-module(extract(car modules))data)(traverse(car modules)))data)))((null? modules)data))))))
(define(apropos-fold-accessible module)"FIXME: Docs incomplete."(make-fold-modules(lambda()(list module))(lambda(m)(fob-info m #:uses))identity))
(define(root-modules)(let((root(unique-fob #:root)))(cons root(submodules(nested-ref root(quote(%%app modules)))))))
(define(submodules m)(hash-fold(lambda(name var data)(let((obj(variable-ref var)))(if(eq?(quote directory)(fob-info obj #:kind))(cons obj data)data)))(quote())(fob-info m #:obarray)))
(define apropos-fold-exported(make-fold-modules root-modules submodules(lambda(fob)(fob-info fob #:public-interface))))
(define apropos-fold-all(make-fold-modules root-modules submodules identity))
(define(source obj)"Return the source code for @var{obj}, a procedure or macro.\nThe source code is an acyclic structured expression (tree of symbols, etc).\nIf @var{obj} does not have source code associated with it, return #f."(cond((procedure? obj)(procedure-source obj))((macro? obj)(procedure-source(macro-transformer obj)))(else #f)))
(define(arity proc)"Display the arity of procedure @var{proc}."(let((arity(procedure-property proc(quote arity))))(display(car arity))(cond((caddr arity)(display " or more"))((not(zero?(cadr arity)))(display " required and ")(display(cadr arity))(display " optional")))(if(and(not(caddr arity))(=(car arity)1)(<=(cadr arity)1))(display " argument")(display " arguments"))(if(closure? proc)(let((formals(cadr(procedure-source proc))))(if(pair? formals)(begin(display ": `")(display(car formals))(let loop((ls(cdr formals)))(cond((null? ls)(display #\'))((not(pair? ls))(display "', the rest in `")(display ls)(display #\'))(else(if(pair?(cdr ls))(display "', `")(display "' and `"))(display(car ls))(loop(cdr ls))))))(begin(display " in `")(display formals)(display #\')))))(display ".\n")))
(define system-module(procedure->syntax(lambda(exp env)(let*((m(or(nested-ref(unique-fob #:root)(append(quote(%%app modules))(cadr exp)))(error "Couldn't find any module named"(cadr exp))))(info(fob-info m #:eval-closure #:name)))(let((s(not(procedure-property(vector-ref info 0)(quote system-module)))))(fob-set-system! m s)(simple-format #f "Module ~S is now a ~A module."(vector-ref info 1)(if s "system" "user")))))))
