(define-module(ice-9 streams)#:export(make-stream stream-car stream-cdr stream-null? list->stream vector->stream port->stream stream->list stream->reversed-list stream->list&length stream->reversed-list&length stream->vector stream-fold stream-for-each stream-map))
(define(make-stream m state)(delay(let((o(m state)))(if(pair? o)(cons(car o)(make-stream m(cdr o)))(quote())))))
(define(stream-car stream)(car(force stream)))
(define(stream-cdr stream)(cdr(force stream)))
(define(stream-null? stream)(null?(force stream)))
(define(list->stream l)(make-stream(lambda(l)l)l))
(define(vector->stream v)(make-stream(let((len(vector-length v)))(lambda(i)(or(= i len)(cons(vector-ref v i)(+ 1 i)))))0))
(define(stream->reversed-list&length stream)(let loop((s stream)(acc(quote()))(len 0))(if(stream-null? s)(values acc len)(loop(stream-cdr s)(cons(stream-car s)acc)(+ 1 len)))))
(define(stream->reversed-list stream)(call-with-values(lambda()(stream->reversed-list&length stream))(lambda(l len)l)))
(define(stream->list&length stream)(call-with-values(lambda()(stream->reversed-list&length stream))(lambda(l len)(values(reverse! l)len))))
(define(stream->list stream)(reverse!(stream->reversed-list stream)))
(define(stream->vector stream)(call-with-values(lambda()(stream->reversed-list&length stream))(lambda(l len)(let((v(make-vector len)))(let loop((i 0)(l l))(if(not(null? l))(begin(vector-set! v(- len i 1)(car l))(loop(+ 1 i)(cdr l)))))v))))
(define (stream-fold f init stream . rest)(if(null? rest)(stream-fold-one f init stream)(stream-fold-many f init(cons stream rest))))
(define(stream-fold-one f r stream)(if(stream-null? stream)r(stream-fold-one f(f(stream-car stream)r)(stream-cdr stream))))
(define(stream-fold-many f r streams)(if(or-map stream-null? streams)r(stream-fold-many f(apply f(let recur((cars(map stream-car streams)))(if(null? cars)(list r)(cons(car cars)(recur(cdr cars))))))(map stream-cdr streams))))
(define (stream-for-each f stream . rest)(if(null? rest)(stream-for-each-one f stream)(stream-for-each-many f(cons stream rest))))
(define(stream-for-each-one f stream)(if(not(stream-null? stream))(begin(f(stream-car stream))(stream-for-each-one f(stream-cdr stream)))))
(define(stream-for-each-many f streams)(if(not(or-map stream-null? streams))(begin(apply f(map stream-car streams))(stream-for-each-many f(map stream-cdr streams)))))
(define (stream-map f stream . rest)(if(null? rest)(make-stream(lambda(s)(or(stream-null? s)(cons(f(stream-car s))(stream-cdr s))))stream)(make-stream(lambda(streams)(or(or-map stream-null? streams)(cons(apply f(map stream-car streams))(map stream-cdr streams))))(cons stream rest))))
(define(port->stream port read)(make-stream(lambda(p)(let((o(read p)))(or(eof-object? o)(cons o p))))port))
