(define-module(ice-9 testing-lib)#:use-module(ice-9 stack-catch)#:use-module(ice-9 regex)#:export(exception:out-of-range exception:unbound-var exception:wrong-num-args exception:wrong-type-arg run-test pass-if expect-fail pass-if-exception expect-fail-exception skip-file! with-test-prefix with-test-prefix* current-test-prefix register-reporter unregister-reporter reporter-registered? make-count-reporter print-counts make-log-reporter full-reporter user-reporter format-test-name test-file-name data-file-name))
(define exception:out-of-range(cons(quote out-of-range)"^Argument .*out of range"))
(define exception:unbound-var(cons(quote unbound-variable)"^Unbound variable"))
(define exception:wrong-num-args(cons(quote wrong-number-of-args)"^Wrong number of arguments"))
(define exception:wrong-type-arg(cons(quote wrong-type-arg)"^Wrong type argument"))
(define(body-check macro body)(and(null? body)(error(simple-format #f "~A: missing body"(macro-name macro)))))
(define run-test(let((test-running #f))(lambda(name expect-pass thunk)(if test-running(error "Nested calls to run-test are not permitted.")(let((test-name(full-name name)))(set! test-running #t)(catch #t(lambda()(let((result(thunk)))(if(eq? result #t)(throw(quote pass)))(if(eq? result #f)(throw(quote fail)))(throw(quote unresolved))))(lambda (key . args)(case key((pass)(report(if expect-pass(quote pass)(quote upass))test-name))((fail)(report(if expect-pass(quote fail)(quote xfail))test-name))((unresolved untested unsupported)(report key test-name))((quit)(report(quote unresolved)test-name)(quit))(else(report(quote error)test-name(cons key args))))))(set! test-running #f))))))
(defmacro pass-if (name . body)(body-check pass-if body)(quasiquote(run-test(unquote name)#t(lambda()(unquote-splicing body)))))
(defmacro expect-fail (name . body)(body-check expect-fail body)(quasiquote(run-test(unquote name)#f(lambda()(unquote-splicing body)))))
(define(run-test-exception name exception expect-pass thunk)(run-test name expect-pass(lambda()(stack-catch(car exception)(lambda()(thunk)#f)(lambda (key proc message . rest)(cond((string-match(cdr exception)message)#t)((and(eq?(quote misc-error)(car exception))(list? rest)(string-match(cdr exception)(apply simple-format #f message(car rest))))#t)(else(apply throw key proc message rest))))))))
(defmacro pass-if-exception (name exception . body)(body-check pass-if-exception body)(quasiquote((unquote run-test-exception)(unquote name)(unquote exception)#t(lambda()(unquote-splicing body)))))
(defmacro expect-fail-exception (name exception . body)(body-check expect-fail-exception body)(quasiquote((unquote run-test-exception)(unquote name)(unquote exception)#f(lambda()(unquote-splicing body)))))
(define(skip-file! reason)(throw(quote skip-file)reason))
(define(format-test-name name)(call-with-output-string(lambda(port)(let loop((name name)(separator ""))(if(pair? name)(begin(display separator port)(display(car name)port)(loop(cdr name)": ")))))))
(define(full-name name)(append(current-test-prefix)(list name)))
(define prefix-fluid(make-fluid))
(fluid-set! prefix-fluid(quote()))
(define(current-test-prefix)(fluid-ref prefix-fluid))
(define(with-test-prefix* prefix thunk)(with-fluids((prefix-fluid(append(fluid-ref prefix-fluid)(list prefix))))(thunk)))
(defmacro with-test-prefix (prefix . body)(body-check with-test-prefix body)(quasiquote(with-test-prefix*(unquote prefix)(lambda()(unquote-splicing body)))))
(define reporters(quote()))
(define default-reporter #f)
(define(register-reporter reporter)(if(memq reporter reporters)(error "register-reporter: reporter already registered: " reporter))(set! reporters(cons reporter reporters)))
(define(unregister-reporter reporter)(if(memq reporter reporters)(set! reporters(delq! reporter reporters))(error "unregister-reporter: reporter not registered: " reporter)))
(define(reporter-registered? reporter)(if(memq reporter reporters)#t #f))
(define (report . args)(if(pair? reporters)(for-each(lambda(reporter)(apply reporter args))reporters)(apply default-reporter args)))
(define result-tags(quote((pass "PASS" "passes:                 ")(fail "FAIL" "failures:               ")(upass "UPASS" "unexpected passes:      ")(xfail "XFAIL" "expected failures:      ")(unresolved "UNRESOLVED" "unresolved test cases:  ")(untested "UNTESTED" "untested test cases:    ")(unsupported "UNSUPPORTED" "unsupported test cases: ")(error "ERROR" "errors:                 "))))
(define important-result-tags(quote(fail upass unresolved error)))
(define (print-result port result name . args)(let*((tag(assq result result-tags))(label(if tag(cadr tag)#f)))(if label(begin(display label port)(display ": " port)(display(format-test-name name)port)(if(pair? args)(begin(display " - arguments: " port)(write args port)))(newline port))(error "(ice-9 testing-lib) FULL-REPORTER: unrecognized result: " result))))
(define(make-count-reporter)(let((counts(map(lambda(tag)(cons(car tag)0))result-tags)))(list(lambda (result name . args)(let((pair(assq result counts)))(if pair(set-cdr! pair(+ 1(cdr pair)))(error "count-reporter: unexpected test result: "(cons result(cons name args))))))(lambda()(append counts(quote()))))))
(define (print-counts results . port?)(let((port(if(pair? port?)(car port?)(current-output-port))))(newline port)(simple-format port "Totals for this test run:\n")(for-each(lambda(tag)(let((result(assq(car tag)results)))(if result(simple-format port "~A~A\n"(caddr tag)(cdr result))(simple-format port "Test suite bug: no total available for `~A'\n"(car tag)))))result-tags)(newline port)))
(define(make-log-reporter file)(let((port(if(output-port? file)file(open-output-file file))))(lambda args(apply print-result port args)(force-output port))))
(define (full-reporter . args)(apply print-result(current-output-port)args))
(define (user-reporter result name . args)(if(memq result important-result-tags)(apply full-reporter result name args)))
(set! default-reporter full-reporter)
(define(test-file-name filename)filename)
(define(data-file-name filename)filename)
