(define-module(ice-9 optargs-kw)#:export(bound? let-optional let-optional* let-keywords let-keywords* lambda* define* define*-public defmacro* defmacro*-public))
(defmacro bound?(var)(quasiquote(catch(quote misc-error)(lambda()(unquote var)(not(eq?(unquote var)(unquote(variable-ref(make-undefined-variable))))))(lambda args #f))))
(defmacro let-optional (REST-ARG BINDINGS . BODY)(let-optional-template REST-ARG BINDINGS BODY(quote let)))
(defmacro let-optional* (REST-ARG BINDINGS . BODY)(let-optional-template REST-ARG BINDINGS BODY(quote let*)))
(defmacro let-keywords (REST-ARG ALLOW-OTHER-KEYS? BINDINGS . BODY)(let-keywords-template REST-ARG ALLOW-OTHER-KEYS? BINDINGS BODY(quote let)))
(defmacro let-keywords* (REST-ARG ALLOW-OTHER-KEYS? BINDINGS . BODY)(let-keywords-template REST-ARG ALLOW-OTHER-KEYS? BINDINGS BODY(quote let*)))
(define(let-o-k-template REST-ARG BINDINGS BODY let-type proc)(let((bindings(map(lambda(x)(if(list? x)x(list x(variable-ref(make-undefined-variable)))))BINDINGS)))(quasiquote((unquote let-type)(unquote(map proc bindings))(unquote-splicing BODY)))))
(define(let-optional-template REST-ARG BINDINGS BODY let-type)(if(null? BINDINGS)(quasiquote(let()(unquote-splicing BODY)))(let-o-k-template REST-ARG BINDINGS BODY let-type(lambda(optional)(quasiquote((unquote(car optional))(cond((not(null?(unquote REST-ARG)))(let((result(car(unquote REST-ARG))))(unquote(list(quote set!)REST-ARG(quasiquote(cdr(unquote REST-ARG)))))result))(else(unquote(cadr optional))))))))))
(define(let-keywords-template REST-ARG ALLOW-OTHER-KEYS? BINDINGS BODY let-type)(if(null? BINDINGS)(quasiquote(let()(unquote-splicing BODY)))(let*((kb-list-gensym(gensym "kb:G"))(bindfilter(lambda(key)(quasiquote((unquote(car key))(cond((assq(quote(unquote(car key)))(unquote kb-list-gensym))=> cdr)(else(unquote(cadr key)))))))))(quasiquote(let*((ra->kbl(unquote rest-arg->keyword-binding-list))((unquote kb-list-gensym)(ra->kbl(unquote REST-ARG)(quote(unquote(map(lambda(x)(symbol->keyword(if(pair? x)(car x)x)))BINDINGS)))(unquote ALLOW-OTHER-KEYS?))))(unquote(let-o-k-template REST-ARG BINDINGS BODY let-type bindfilter)))))))
(define(rest-arg->keyword-binding-list rest-arg keywords allow-other-keys?)(if(null? rest-arg)()(let loop((first(car rest-arg))(rest(cdr rest-arg))(accum()))(let((next(lambda(a)(if(null?(cdr rest))a(loop(cadr rest)(cddr rest)a)))))(if(keyword? first)(cond((memq first keywords)(if(null? rest)(error "Keyword argument has no value.")(next(cons(cons(keyword->symbol first)(car rest))accum))))((not allow-other-keys?)(error "Unknown keyword in arguments."))(else(if(null? rest)accum(next accum))))(if(null? rest)accum(loop(car rest)(cdr rest)accum)))))))
(defmacro lambda* (ARGLIST . BODY)(parse-arglist ARGLIST(lambda(non-optional-args optionals keys aok? rest-arg)(if(not(and-map symbol? non-optional-args))(error "Syntax error in fixed argument declaration."))(if(not(and-map ext-decl? optionals))(error "Syntax error in optional argument declaration."))(if(not(and-map ext-decl? keys))(error "Syntax error in keyword argument declaration."))(if(not(or(symbol? rest-arg)(eq? #f rest-arg)))(error "Syntax error in rest argument declaration."))(let((rest-gensym(or rest-arg(gensym "lambda*:G"))))(if(not(and(null? optionals)(null? keys)))(quasiquote(lambda((unquote-splicing non-optional-args)unquote rest-gensym)(unquote-splicing(if(and(not(null? BODY))(string?(car BODY)))(list(car BODY))(quote())))(let-optional*(unquote rest-gensym)(unquote optionals)(let-keywords*(unquote rest-gensym)(unquote aok?)(unquote keys)(unquote-splicing(if(and(not rest-arg)(null? keys))(quasiquote((if(not(null?(unquote rest-gensym)))(error "Too many arguments."))))(quote())))(let()(unquote-splicing BODY))))))(quasiquote(lambda((unquote-splicing non-optional-args)unquote(if rest-arg rest-arg(quote())))(unquote-splicing BODY))))))))
(define(ext-decl? obj)(or(symbol? obj)(and(list? obj)(= 2(length obj))(symbol?(car obj)))))
(define(parse-arglist arglist cont)(define(split-list-at val lst cont)(cond((memq val lst)=>(lambda(pos)(if(memq val(cdr pos))(error(with-output-to-string(lambda()(map display(quasiquote((unquote val)" specified more than once in argument list."))))))(cont(reverse(cdr(memq val(reverse lst))))(cdr pos)#t))))(else(cont lst(quote())#f))))(define(parse-opt-and-fixed arglist keys aok? rest cont)(split-list-at #:optional arglist(lambda(before after split?)(if(and split?(null? after))(error "#:optional specified but no optional arguments declared.")(cont before after keys aok? rest)))))(define(parse-keys arglist rest cont)(split-list-at #:allow-other-keys arglist(lambda(aok-before aok-after aok-split?)(if(and aok-split?(not(null? aok-after)))(error "#:allow-other-keys not at end of keyword argument declarations.")(split-list-at #:key aok-before(lambda(key-before key-after key-split?)(cond((and aok-split?(not key-split?))(error "#:allow-other-keys specified but no keyword arguments declared."))(key-split?(cond((null? key-after)(error "#:key specified but no keyword arguments declared."))((memq #:optional key-after)(error "#:optional arguments declared after #:key arguments."))(else(parse-opt-and-fixed key-before key-after aok-split? rest cont))))(else(parse-opt-and-fixed arglist(quote())#f rest cont)))))))))(define(parse-rest arglist cont)(cond((null? arglist)(cont(quote())(quote())(quote())#f #f))((not(pair? arglist))(cont(quote())(quote())(quote())#f arglist))((not(list? arglist))(let*((copy(improper-list-copy arglist))(lp(last-pair copy))(ra(cdr lp)))(set-cdr! lp(quote()))(if(memq #:rest copy)(error "Cannot specify both #:rest and dotted rest argument.")(parse-keys copy ra cont))))(else(split-list-at #:rest arglist(lambda(before after split?)(if split?(case(length after)((0)(error "#:rest not followed by argument."))((1)(parse-keys before(car after)cont))(else(error "#:rest argument must be declared last.")))(parse-keys before #f cont)))))))(parse-rest arglist cont))
(define(improper-list-copy l)(let((out(quote())))(let loop((in l)(prev(quote())))(if(pair? in)(let((cur(cons(car in)(cdr in))))(if(null? prev)(set! out cur)(set-cdr! prev cur))(loop(cdr in)cur))out))))
(defmacro define* (ARGLIST . BODY)(define*-guts(quote define)ARGLIST BODY))
(defmacro define*-public (ARGLIST . BODY)(define*-guts(quote define-public)ARGLIST BODY))
(define(define*-guts DT ARGLIST BODY)(define(nest-lambda*s arglists)(if(null? arglists)BODY(quasiquote((lambda*(unquote(car arglists))(unquote-splicing(nest-lambda*s(cdr arglists))))))))(define(define*-guts-helper ARGLIST arglists)(let((first(car ARGLIST))(al(cons(cdr ARGLIST)arglists)))(if(symbol? first)(quasiquote((unquote DT)(unquote first)(unquote-splicing(nest-lambda*s al))))(define*-guts-helper first al))))(if(symbol? ARGLIST)(quasiquote((unquote DT)(unquote ARGLIST)(unquote-splicing BODY)))(define*-guts-helper ARGLIST(quote()))))
(defmacro defmacro* (NAME ARGLIST . BODY)(defmacro*-guts(quote define)NAME ARGLIST BODY))
(defmacro defmacro*-public (NAME ARGLIST . BODY)(defmacro*-guts(quote define-public)NAME ARGLIST BODY))
(define(defmacro*-guts DT NAME ARGLIST BODY)(quasiquote((unquote DT)(unquote NAME)((unquote(lambda(transformer)(defmacro:transformer transformer)))(lambda*(unquote ARGLIST)(unquote-splicing BODY))))))
